/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	フレームワーク　抽象基底例外クラス
//			変更履歴
//				2004/01/08 新規作成 二條
//
package jp.co.ntt.lms.xms.framework;

/**
 * フレームワーク　抽象基底例外クラス<BR>
 * リクエスト処理で発生した例外はすべてこのクラスから派生した
 * 例外を投げる。
 * 
 * @author nijou
 *
 */
public abstract class XmsException extends Exception {
	/**
	 * 改行文字列
	 */
	public static final String LINE_SEPARATOR;
	
	static {
		String lf = null;
		lf = System.getProperty("line.separator");
		LINE_SEPARATOR = ( (lf != null) ? lf : "");
	}
	

	/**
	 * この例外の原因となった例外を保持する
	 */
	protected Throwable cause;
	

	/**
	 * デフォルトコンストラクタ
	 */
	public XmsException() {

	}
	
	/**
	 * この例外の原因となった元の例外を設定する。<BR>
	 * nullも許可する。
	 * @param cause 原因となった例外
	 */
	public XmsException(Throwable cause) {
		this.cause = cause;	
	}
	
	/**
	 * メッセージを設定する。
	 */
	public XmsException( String message ) {
		super(message);
	}
	
	/**
	 * この例外の原因となった例外を返す。<BR>
	 * 設定されていない場合はnullを返す。
	 */
	public Throwable getCause() {
		return cause;	
	}
	
	

	/**
	 * @see java.lang.Throwable#getMessage()
	 */
	public String getMessage() {
		StringBuffer buffer = null;
		
		buffer = new StringBuffer();
		
		buffer.append( super.getMessage() );
		if ( cause != null ) {
			buffer.append( LINE_SEPARATOR );
			buffer.append( cause.getMessage() );
		}
		
		return buffer.toString();
	}
	
	

	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		StringBuffer buffer = null;
		
		buffer = new StringBuffer();
		
		buffer.append( super.toString() );
		if ( cause != null ) {
			buffer.append( LINE_SEPARATOR );
			buffer.append( cause.toString() );
		}
		
		return buffer.toString();
	}

}
